//
//	gnuboxAppUi.cpp - main Gnubox AppUi cpp file.
//
//  Gnubox is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  Gnubox is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with Gnubox; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//	Copyright (C) 2002 Mal Minhas.
//
//	Revision history:
//	=================
//	28/08/02:	First version of Gnubox started.

#include <eikenv.h>
#include "gnuboxAppUi.h"
#include "gnuboxContainer.h"
#include <gnubox.rsg>
#include "gnubox.hrh"
#include "cdb.h"
#include "routedump.h"

void CGnuboxAppUi::ConstructL()
/**
	CGnuboxAppUi::ConstructL()
*/
	{
	BaseConstructL();
	// Need to set right mode after parsing CommDB.
	//iMode=TConnectionMode());
        iMode=PhoneCfg::GetSettingsWFallback(GetDocument()->RetrieveRecordL(_L("Mode")));
	iAppContainer = new (ELeave) CGnuboxContainer;
	//CleanupStack::PushL(iAppContainer);
	iAppContainer->ConstructL(ClientRect(), this);
	//CleanupStack::Pop();
	AddToStackL(iAppContainer);
	
	}

CGnuboxAppUi::~CGnuboxAppUi()
/**
	CGnuboxAppUi::~CGnuboxAppUi()
	Destructor
*/
	{
	if(iAppContainer)
		{
		RemoveFromStack(iAppContainer);
		delete iAppContainer;
		}
   }

void CGnuboxAppUi::DynInitMenuPaneL(
	TInt /*aResourceId*/,CEikMenuPane* /*aMenuPane*/)
/**
	CGnuboxAppUi::DynInitMenuPaneL(TInt aResourceId,
	CEikMenuPane* aMenuPane)
	This function is called by the EIKON framework just
	before it displays a menu pane. Its default implementation
	is empty, and by overriding it, the application can set the
	state of menu items dynamically according
	to the state of application data.
*/
	{
	}

TKeyResponse CGnuboxAppUi::HandleKeyEventL(
	const TKeyEvent& /*aKeyEvent*/,TEventCode /*aType*/)
/**
	CGnuboxAppUi::HandleKeyEventL(
	 const TKeyEvent& aKeyEvent,TEventCode aType)
*/
	{
	return EKeyWasNotConsumed;
	}

void CGnuboxAppUi::HandleCommandL(TInt aCommand)
/**
	CGnuboxAppUi::HandleCommandL(TInt aCommand)
*/
{
  switch (aCommand)
    {
    case EEikCmdExit:
      Exit();
      break;
      /*    case EGnuboxCmdAppInfraredDirect:
      if (iMode != EInfraredDirect)
        iAppContainer->SwitchModeL(EInfraredDirect);
      else
        iEikonEnv->InfoMsg(_L("Already is Direct Infrared"));
      break;
    case EGnuboxCmdAppBluetoothDirectSer:
      iAppContainer->SwitchModeL(EBluetoothSerial);
      break;
    case EGnuboxCmdAppBluetoothDirectLan:
      iAppContainer->SwitchModeL(EBluetoothLANAccess);
      break;
    case EGnuboxCmdAppBluetoothDirectMR:
      iAppContainer->SwitchModeL(EBluetoothMR);
      break;
    case EGnuboxCmdAppCableDirectMR:
      iAppContainer->SwitchModeL(ECableDirect);
      break;
    case EGnuboxCmdAppBluetoothDirectDun:
      iAppContainer->SwitchModeL(EBluetoothDUN);
      break;
    case EGnuboxCmdAppInfraredDialup:
      if (iMode != EInfraredDialup)
        iAppContainer->SwitchModeL(EInfraredDialup);
      else
        iEikonEnv->InfoMsg(_L("Already is Dialup Infrared"));
    break;
    case EGnuboxCmdAppCSD_GPRS:
      if (iMode != ECSD_GPRS)
        iAppContainer->SwitchModeL(ECSD_GPRS);
      else
        iEikonEnv->InfoMsg(_L("Already is default CSD/GPRS"));
      break;
*/
    case EGnuboxCmdAppDumpCommDb:
      {
        iEikonEnv->InfoMsg(_L("Allow 2min for work"));
        CCommDbDump *cd = CCommDbDump::NewL();
        CleanupStack::PushL(cd);
        cd->DumpDBtoFileL(_L("c:\\documents\\Media files\\document\\Unfiled\\commdb.txt"));
        CleanupStack::PopAndDestroy(1);
        iEikonEnv->InfoMsg(_L("Done. See c:document\\Unfiled\\commdb.txt"));
        break;
      }
    case EGnuboxCmdAppDumpCommDbNew:
      {
        iEikonEnv->InfoMsg(_L("Allow 2min for work"));
        CCommDbDump *cd = CCommDbDump::NewL();
        CleanupStack::PushL(cd);
        cd->DumpDBtoFileXL(_L("c:\\documents\\Media files\\document\\Unfiled\\commdb.txt"));
        CleanupStack::PopAndDestroy();
        iEikonEnv->InfoMsg(_L("Done. See c:document\\Unfiled\\commdb.txt"));
        break;
      }
    case EGnuboxCmdAppDumpInfo:
      {
        iEikonEnv->InfoMsg(_L("Allow 1min for work"));
        CInfoDump cd;
        cd.ConstructL();
        cd.DumpInfotoFileL(_L("c:\\documents\\Media files\\document\\Unfiled\\route.txt"));
        iEikonEnv->InfoMsg(_L("Done. See c:document\\Unfiled\\route.txt"));
        break;
      }
    case EGnuboxCmdAppDumpCommInfo:
      {
        iEikonEnv->InfoMsg(_L("Allow 1min for work"));
        CInfoDump cd;
        cd.ConstructL();
        cd.DumpSerInfotoFileL(_L("c:\\documents\\Media files\\document\\Unfiled\\comm.txt"));
        iEikonEnv->InfoMsg(_L("Done. See c:document\\Unfiled\\comm.txt"));
        break;
      }
    case EGnuboxCmdAppSetModemID: 
      {
        iAppContainer->SetDataModemL(TRUE);
        break;
      }
    case EGnuboxCmdAppUnsetModemID: 
      {
        iAppContainer->SetDataModemL(FALSE);
        break;
      }
    case EGnuboxCmdAppSetModemD2: 
      {
        iAppContainer->SetModemL(EData,2);
        break;
      }
    case EGnuboxCmdAppSetModemD6: 
      {
        iAppContainer->SetModemL(EData,6);
        break;
      }
    case EGnuboxCmdAppSetModemP2: 
      {
        iAppContainer->SetModemL(EPhone,2);
        break;
      }
    case EGnuboxCmdAppSetModemP6: 
      {
        iAppContainer->SetModemL(EPhone,6);
        break;
      }
    case EGnuboxCmdAddMRouterDefRoute: 
      {
        iEikonEnv->InfoMsg(_L("Allow 1min for work"));
        CInfoDump cd;
        cd.ConstructL();
        cd.AddMRouterDefaultRouteL(_L("c:\\documents\\Media files\\document\\Unfiled\\nroute.txt"));
        iEikonEnv->InfoMsg(_L("Done. See c:document\\Unfiled\\nroute.txt"));
        break;
      }

    default:
      const TCfgEntry * ce = PhoneCfg::GetSettings(aCommand);
      if (ce) {
        iAppContainer->SwitchModeL(ce);
      }
      break;
    }
}
