# $Id: rules.make,v 1.5 2004/07/14 15:57:54 izakb Exp $
#
# makefile to be included after defining the variables commented below
#
# http://www.alfonsomartone.itb.it -- under GNU GPL license -- April 2004
#
# --- generation of a .app program:
#
#APP = PVoxel          application name (only alphanumeric characters and "_")
#DSC = A Voxel Demo    short description used in P900 Launcher/Uninstall menu
#CPP = appui dialogs   the list of .cpp source files (without .cpp extension)
#RSC = voxel           the name of the resource file (without .rss extension)
#LIC = licensefile     name of optional license text (without .txt extension)
#LIB = euser cone gdi  the list of libraries to link (without .lib extension)
#BMP = icon icon_mask  pairs of bitmaps/bitmasks to be included (optional)
#UID = 0f30d3c8        the unique application ID (always as eight hex digits)
#VER = 0.58            the version number (always as: digit dot digit digit)
#
# --- generation of an optional .exe program (needs .app configuration above)
#EXE = base graph      the list of .c++ source files (without .c++ extension)
#LEX = euser ws32      the list of libraries to link (without .lib extension)
#
#RSF = standard.def    Runtime support files
#ABT = ok.mbm          Additional Build Targets (require rule in Makefile)

# --- you shouldn't need to change anything below this line ---

ifndef APP
$(error the APP (application name) is not defined)
endif

ifndef DSC
$(error the DSC (package description) is not defined)
endif

ifndef CPP
$(error the CPP (source file list) is not defined)
endif

ifndef RSC
$(error the RSC (resource file name) is not defined)
endif

ifndef LIB
$(error the LIB (library file list) is not defined)
endif

ifndef UID
$(error the UID (application unique identifier) is not defined)
endif

ifndef VER
$(error the VER (application version number) is not defined)
endif


OPTI = -O2 -s
UID1 = 1000007a
UID2 = 100039ce

#OPLA = '(0x101f80be),1,0,0,{"SonyEricssonP900PlatformProductID"}'
OPLA = '(0x101F617B),2,0,0,{"UIQ20ProductID"}'
# OPLA = '(0x101F7960),0,0,0,{"Series60ProductID"}'

DSDK = c:\\Mobile\\Symbian\\UIQ_21\\epoc32
#DGCC = $(DSDK)/bin
DGCC = $(DSDK)\\gcc\\bin
DBIN = $(DSDK)/tools
DLIB = $(DSDK)/release/armi/urel
#DINC = $(DSDK)/sdk/include
#DINC = /c/Mobile/Symbian/UIQ_21/epoc32/include/
DINC = c:\\Mobile\\Symbian\\UIQ_21\\epoc32\\include

FAPP = $(APP).app
FPKG = $(APP).pkg
FSIS = $(APP)_$(VER).sis
FRSS = $(RSC).rss
FRSC = $(APP).rsc
FRPP = $(RSC).rpp
FRST = $(RSC).rst
FRSG = $(RSC).rsg
FCMD = $(APP).cmd
FEXP = $(APP).exp
FPRG = $(APP).prg
FEXT = $(APP).ext
FEXC = $(APP).exc
FINF = $(APP).inf
FBAS = $(APP).bas
FORG = $(APP).org
FMAP = $(APP).map
FDEF = $(APP).def
FBIN = $(APP).bin
FAIF = $(APP).aif
FMBM = $(APP).mbm
FSPE = $(APP).spc

ifdef LIC
FLIC = $(LIC).txt
endif

ifdef EXE
FEXE = $(APP).exe
endif

ONAM = --dllname $(shell echo $(APP) | tr a-z A-Z)[$(UID)].app
OVER = $(shell echo $(VER) | tr . ,),0
OINC = -I. -I../include -I$(DINC) -I$(DINC)/libc
OUID = -uid1 0x$(UID1) -uid2 0x$(UID2) -uid3 0x$(UID)
OEUI = -uid1 0x$(UID1) -uid2 0x00000000 -uid3 0x00000000
OMAP = -Map $(FMAP)
OGCC = -fomit-frame-pointer -march=armv4t -mthumb-interwork -pipe -nostdinc
OGCC+= -Wall -Wno-ctor-dtor-privacy -Wno-unknown-pragmas $(OINC)
OGCC+= -DNDEBUG -D_UNICODE -D__SYMBIAN32__ -D__GCC32__ -D__EPOC32__
OGCC+= -D__MARM__ -D__MARM_ARMI__
OGCC+= -D__UID__=0x$(UID) -D__VER__="$(VER)" -D__APP__="$(APP)"

WINE = /usr/local/bin/wine --
PSIS = $(DBIN)/makesis.exe
#PSIS = /usr/bin/makesis
PETR = $(DBIN)/petran.exe
#PETR = /usr/bin/petran
PRCO = $(DBIN)/rcomp.exe
PMBM = $(DBIN)/bmconv.exe
PGCC = $(DGCC)/gcc $(OGCC) $(OINC)
PCPP = $(DGCC)/cpp $(OINC) -DLANGUAGE_SC -D_EPOC32_7
PGLD = $(DGCC)/ld -s -e _E32Dll -u _E32Dll --dll
PGLE = $(DGCC)/ld -s -e _E32Startup -u _E32Startup
PDLL = $(DGCC)/dlltool -m arm_interwork --as $(DGCC)/arm-epoc-pe-as
PAIF = $(DGCC)/genaif
PBMP = $(DBIN)/bmpinfo

IDLL = $(DLIB)/edll.lib
IEXE = $(DLIB)/eexe.lib
ILIB = $(DLIB)/ecrt0.lib $(DLIB)/egcc.lib

ifdef BMP
LTMP += $(FSPE) $(FMBM)
LPKG = $(FAIF)
endif

LPKG+= $(FRSC) $(FAPP)
LCPP = $(patsubst %,%.cpp,$(CPP))
LEXE = $(patsubst %,%.c++,$(EXE))
LOBJ = $(patsubst %,%.o,$(CPP))
LEOB = $(patsubst %,%.o,$(EXE))
LLIB = $(patsubst %,$(DLIB)/%.lib,$(LIB))
LELI = $(patsubst %,$(DLIB)/%.lib,$(LEX))
LSIS = $(APP)*.sis
LOUT = $(LSIS)
LBMP = $(patsubst %,%.bmp,$(BMP))
LTMP+= $(LOBJ) $(FPKG) $(FRST) $(FRSG) $(FCMD) $(FEXP) $(FBAS) $(FDEF)
LTMP+= $(FBIN) $(FRPP) $(FINF) $(LPKG)

ifdef EXE
LTMP+= $(LEOB) $(FEXE) $(FMAP) $(FEXC) $(FEXT) $(FORG) $(FPRG)
LPKG+= $(FEXE)
endif


# --- general compilation rules

$(FSIS): $(FPKG) $(LPKG) $(FLIC) $(ABT)
	@echo -- building $(FSIS)
	$(PSIS) $(FPKG) $(FSIS)

$(FPKG): $(LPKG) $(FLIC)
	@echo -- building $(FPKG)
	@echo '&EN' >$(FPKG)
	@echo '#{"'"$(DSC)"'"},(0x'$(UID)'),'$(OVER) >>$(FPKG)
	@echo $(OPLA) >>$(FPKG)
ifdef FLIC
	@echo '"$(FLIC)"-"",FT,TA' >>$(FPKG)
endif
	@for i in $(LPKG); do 		echo '"'$$i'"-"!:\system\apps\'$(APP)'\'$$i'"' >>$(FPKG); done
ifdef RSF
	@for i in $(RSF); do 		echo '"'$$i'"-"!:\system\apps\'$(APP)'\'$$i'"' >>$(FPKG); done
endif
	@for i in $(ABT); do 		echo '"'$$i'"-"!:\system\apps\'$(APP)'\'$$i'"' >>$(FPKG); done

$(FRSC): $(FRPP)
	@echo -- building $(FRSC)
	rm -f $(FRSC) $(FRST)
	$(PRCO) -u -o$(FRSC) -h$(FRST) -i$(FRSS) -s$(FRPP)
	cp $(FRST) $(FRSG)

$(FRPP): $(FRSS)
	@echo -- building $(FRPP)
	$(PCPP) < $(FRSS) | perl -pe 's,\r,,; s,\n,\r\n,' > $(FRPP)

$(FAPP): $(FCMD)
	@echo -- building $(FAPP)
	@$(PETR) $(FCMD) $(FAPP) -nocall $(OUID)

$(FCMD): $(FEXP)
	@echo -- building intermediate $(FCMD)
	@$(PGLD) -o $(FCMD) $(FEXP) $(IDLL) $(LOBJ) $(LLIB)

$(FEXP): $(FBAS) $(FINF)
	@echo -- building intermediate $(FEXP)
	@$(PDLL) --def $(FINF) $(ONAM) --output-exp $(FEXP) --base-file $(FBAS)

$(FBAS): $(FINF)
	@echo -- building intermediate $(FBAS)
	@$(PGLD) --base-file $(FBAS) -o $(FBIN) $(IDLL) $(LOBJ) $(LLIB)

$(FINF): $(LOBJ)
	@echo -- building intermediate $(FINF)
	@$(PDLL) --output-def $(FINF) $(LOBJ)
#	@perl -pi -e 's,\n,\r\n, ; s/ ;.*/ NONAME/' $(FINF)
	@perl -pi -e 's,\n,\r\n, ; s/ ;.*/; NONAME/' $(FINF)


ifdef EXE

$(FEXE): $(FPRG)
	@echo -- building $(FEXE)
	@$(PETR) $(FPRG) $(FEXE) -nocall $(OEUI)

$(FPRG): $(FEXT)
	@echo -- building intermediate $(FPRG)
	@$(PGLE) $(OMAP) -o $(FPRG) $(IEXE) $(FEXT) $(LEOB) $(ILIB) $(LELI)

$(FEXT): $(FORG)
	@echo -- building intermediate $(FEXT)
	@$(PDLL) --base-file $(FORG) --output-exp $(FEXT)

$(FORG): $(LEOB)
	@echo -- building intermediate $(FORG)
	@$(PGLE) --base-file $(FORG) -o $(FEXC) $(IEXE) $(LEOB) $(ILIB) $(LELI)

endif


ifdef BMP

$(FMBM): $(LBMP)
	@echo -- building $(FMBM)
	@$(PMBM) /q $(FMBM) $(shell $(PBMP) $(LBMP))

$(FSPE): $(FMBM)
	@echo -- building $(FSPE)
	@echo mbmfile=$(FMBM) >$(FSPE)
	@echo "ElangEnglish=$(DSC)" >>$(FSPE)
	@echo "hidden=0" >>$(FSPE)
	@echo "embeddability=0" >>$(FSPE)
	@echo "newfile=1" >>$(FSPE)

$(FAIF): $(FSPE)
	@echo -- building $(FAIF)
	$(PAIF) -u 0x$(UID) $(FSPE) $(FAIF)

endif


%.o: %.cpp
	@echo -- compiling $*.cpp
	$(PGCC) -D__DLL__ $(OPTI) -c $*.cpp

%.o: %.c++
	@echo -- compiling $*.c++
	$(PGCC) -D__EXE__ $(OPTI) -c $*.c++

%.d: %.cpp
	@echo -- creating dependency for $@
	@$(PGCC) -D__DLL__ -MM $< > $@.$$$$; 	@sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; 	@rm -f $@.$$$$

#include $(sources:.cpp=.d)


# --- aaaah, finally...

target:: all

all:: input_files_must_exist $(LOBJ) $(LEOB) $(LPKG) $(FSIS)
	@echo "-- build completed; packaged file is:"
	@ls -o $(FSIS)

input_files_must_exist: $(LCPP) $(LLIB) $(IDLL) $(FRSC) $(LBMP) $(FLIC)

clear:
	rm -f $(LTMP)

clean:
	rm -f $(LTMP) $(LOUT) $(ABT)

# ---

